#ifndef OSP_CORE_FILESYSTEM_H
#define OSP_CORE_FILESYSTEM_H

#include <list>
#include <regex>
#include <string>
#include <osp/exports/core_export.h>

namespace osp {

namespace filesystem {

enum class PathType
{
    Absolute,
    Relative
};

bool OSP_CORE_EXPORT exists(const std::string &path);
bool OSP_CORE_EXPORT isFile(const std::string &path);
bool OSP_CORE_EXPORT isDirectory(const std::string &path);
bool OSP_CORE_EXPORT createDirectory(const std::string &path);
bool OSP_CORE_EXPORT removeAll(const std::string &path);
std::vector<std::string> OSP_CORE_EXPORT filesInDirectory(const std::string &directory, PathType type = PathType::Relative, std::regex regex = std::regex(".*"));

}

}

#endif
