#ifndef OSP_FPSCOUNTER_H
#define OSP_FPSCOUNTER_H

#include <chrono>
#include <queue>
#include <osp/exports/core_export.h>

namespace osp
{

class OSP_CORE_EXPORT FpsCounter
{
public:
    using Clock = std::chrono::high_resolution_clock;
    using TimePoint = std::chrono::time_point<Clock>;
    using Period = TimePoint::period;

    FpsCounter(size_t maxQueueSize = 5);

    float trigger();
    void reset();

private:
    std::queue<TimePoint> m_queue;
    size_t m_maxQueueSize;
};

}

#endif // OSP_FPSCOUNTER_H
