#ifndef OSP_OBJECT_H
#define OSP_OBJECT_H

#include <list>
#include <string>
#include <osp/exports/core_export.h>

namespace osp {

class OSP_CORE_EXPORT Object
{
public:
    explicit Object(std::string name, Object *parent = nullptr);
    virtual ~Object();

    Object *parent() const;
    std::string name() const;

    Object *child(std::string name) const;
    const std::list<Object *> childs() const;

private:
    void addChild(Object *child);
    void removeChild(Object *child);

    Object *m_parent;
    std::string m_name;
    std::list<Object *> m_childs;
};

}

#endif // OSP_OBJECT_H
