#ifndef OSP_UTILITY_H
#define OSP_UTILITY_H

#include <memory>
#include <string>
#include <osp/exports/core_export.h>

namespace osp {

template<typename T, typename... Args>
std::unique_ptr<T> make_unique(Args &&... args)
{
    return std::unique_ptr<T>(new T(std::forward<Args>(args)...));
}

template <typename T>
struct make_shared_enabler : public T
{
    template <typename... Args>
    make_shared_enabler(Args &&... args) : T(std::forward<Args>(args)...)
    {
    }
};

template <typename T>
using make_unique_enabler = make_shared_enabler<T>;

std::string OSP_CORE_EXPORT numToStr(int i, size_t size);

int64_t OSP_CORE_EXPORT timestamp_us();

} // namespace osp

#endif // OSP_UTILITY_H
