#ifndef OSP_CALIB_IO_H
#define OSP_CALIB_IO_H

#include <osp/calib/camera.h>
#include <osp/calib/projection/epipolarequidistant.h>
#include <osp/calib/projection/equiangular.h>
#include <osp/calib/projection/genericasymmetric.h>
#include <osp/calib/projection/genericradsym.h>
#include <osp/exports/grpc_service_export.h>
#include <osp/grpc/service/osp_types.pb.h>

OSP_GRPC_SERVICE_EXPORT void serialize(const osp::GenericAsymmetricProjection &model, triscape::osp::GenericAsymmetric *proto);
OSP_GRPC_SERVICE_EXPORT void serialize(const osp::GenericRadialSymmetricProjection &model, triscape::osp::GenericRadialSymmetric *proto);
OSP_GRPC_SERVICE_EXPORT void serialize(const osp::Intrinsic &intrinsic, triscape::osp::Intrinsic *proto);
OSP_GRPC_SERVICE_EXPORT void serialize(const osp::Extrinsic &extrinsic, triscape::osp::Extrinsic *proto);
OSP_GRPC_SERVICE_EXPORT void serialize(const osp::Camera &cameraModel, triscape::osp::CameraModel *proto);
OSP_GRPC_SERVICE_EXPORT void deserialize(const triscape::osp::GenericAsymmetric &proto, osp::GenericAsymmetricProjection *model);
OSP_GRPC_SERVICE_EXPORT void deserialize(const triscape::osp::GenericRadialSymmetric &proto, osp::GenericRadialSymmetricProjection *model);
OSP_GRPC_SERVICE_EXPORT void deserialize(const triscape::osp::Intrinsic &proto, osp::Intrinsic *intrinsic);
OSP_GRPC_SERVICE_EXPORT void deserialize(const triscape::osp::Extrinsic &proto, osp::Extrinsic *extrinsic);
OSP_GRPC_SERVICE_EXPORT void deserialize(const triscape::osp::CameraModel &proto, osp::Camera *cameraModel);

#endif // OSP_CALIB_IO_H
