#ifndef MATRIX_H
#define MATRIX_H

#include <QObject>
#include <osp/sdk/device.h>

class Matrix : public QObject
{
    Q_OBJECT
public:
    enum Type
    {
        UInt8,
        UInt16,
        Float
    };
    Q_ENUM(Type)

    Matrix(osp::Matrix<uint8_t, 3> matrix, QObject *parent = nullptr);
    Matrix(osp::Matrix<uint16_t> matrix, QObject *parent = nullptr);
    Matrix(osp::Matrix<osp::Point3d<float>> matrix, QObject *parent = nullptr);

    virtual ~Matrix();

    int rows();
    int cols();
    int channels();
    Type type();
    QByteArray data();

private:
    int m_rows;
    int m_cols;
    int m_channels;
    Type m_type;
    QByteArray m_data;
};


#endif // MATRIX_H
