#ifndef POINTCLOUDENTITY_H
#define POINTCLOUDENTITY_H

#include <QEntity>
#include <QNode>
#include <Qt3DRender>

#include "frame.h"

class PointCloudEntity : public Qt3DCore::QEntity
{
    Q_OBJECT
    Q_PROPERTY(Frame *frame READ frame WRITE setFrame NOTIFY frameChanged)
public:
    PointCloudEntity(Qt3DCore::QNode *parent = nullptr);
    ~PointCloudEntity();

    Frame *frame();
    void setFrame(Frame *frame);

Q_SIGNALS:
    void frameChanged();

private Q_SLOTS:
    void updateGeometry();

private:
    void addMaterial();

    Frame *m_frame;
    Qt3DRender::QGeometryRenderer *m_renderer;
    Qt3DRender::QGeometry *m_geometry;
    Qt3DRender::QAttribute *m_positionAttribute;
    Qt3DRender::QAttribute *m_colorAttribute;
};

#endif // POINTCLOUDENTITY_H
