#ifndef OSP_RANGE_H
#define OSP_RANGE_H

#include <exception>

namespace osp {

template <typename T>
class Range
{
public:
    Range(T min, T max) : m_min(min), m_max(max) {}
    ~Range() = default;

    void set(T min, T max)
    {
        if (min > max)
            throw std::range_error("Min must be less than max.");
        m_min = min;
        m_max = max;
    }

    void setMax(T max) { set(m_min, max); }
    void setMin(T min) { set(min, m_max); }

    T max() { return m_max; }
    T min() { return m_min; }

private:
    T m_min;
    T m_max;
};

} // namespace osp

#endif // OSP_RANGE_H
