#ifndef OSP_SIZE_H
#define OSP_SIZE_H

namespace osp {

template <typename T>
class Size
{
public:
    Size(T width = 0, T height = 0) : m_width(width), m_height(height) {}
    ~Size() = default;

    void setWidth(T width) { m_width = width; }
    void setHeight(T height) { m_height = height; }

    T width() const { return m_width; }
    T height() const { return m_height; }

private:
    T m_width;
    T m_height;
};

template <typename T>
bool operator ==(const Size<T> &lhs, const Size<T> &rhs)
{
    return lhs.width() == rhs.width() && lhs.height() == rhs.height();
}

template <typename T>
bool operator !=(const Size<T> &lhs, const Size<T> &rhs)
{
    return !(lhs == rhs);
}

} // namespace osp

#endif // OSP_SIZE_H
